<template>
  <li class="ui-navbar-list-item contents flex-col items-center md:flex">
    <component
      :is="tag"
      v-if="!wrapperOnly"
      v-slot="slotProps"
      class="my-1 flex items-center space-x-1 rounded p-2 text-sm text-gray-700 outline-none hover:bg-violet-100 hover:text-violet-800 hover:underline focus:bg-violet-100 focus:text-violet-800 focus:underline focus:ring-2 focus:ring-violet-700 aria-current-page:font-bold aria-current-page:text-violet-700 hover:aria-current-page:text-violet-800 focus:aria-current-page:text-violet-800 md:my-0 md:justify-center lg:text-lg [&_svg]:size-[1.25em] [&_svg]:shrink-0 [&_svg]:fill-current"
      :target="$attrs.target || (external && '_blank') || undefined"
      :rel="
        $attrs.rel ||
        (external && 'noopener noreferrer noindex nofollow') ||
        undefined
      "
      :active-class="matchNonExactRoute ? 'text-violet-700 font-bold' : null"
      v-bind="$attrs"
    >
      <slot name="iconLeft" />
      <!--
        The pseudo element styles are used to set the list item width to the width it would have if
        it was active and the bold font was applied. This prevents layout shifts on page navigation.
      -->
      <span
        class="before:invisible before:block before:h-0 before:overflow-hidden before:font-bold before:content-[attr(data-label)]"
        :class="{ 'font-medium': !slotProps?.isActive }"
        :data-label="label"
        ><slot
      /></span>
      <slot name="iconRight">
        <arrow-top-right-on-square-icon
          v-if="tag === 'a' && external"
          class="text-gray-400"
        />
      </slot>
    </component>
    <slot v-else />
  </li>
</template>

<script lang="ts" setup>
import { ArrowTopRightOnSquareIcon } from '@heroicons/vue/20/solid'

defineOptions({
  name: 'UiNavbarListItem',
  inheritAttrs: false,
})

defineProps({
  wrapperOnly: {
    type: Boolean,
    default: false,
  },
  tag: {
    type: String,
    default: 'router-link',
  },
  matchNonExactRoute: {
    type: Boolean,
    default: true,
  },
  external: {
    type: Boolean,
    default: false,
  },
  label: {
    type: String,
    default: '',
  },
})
</script>
